#! perl.exe -w

# Wir versuchen uns mal an einem Variablenlister/Probier-Compiler fr Perl/TextPad.								

############################################################################################################################
#																														   #
#	To utilize this script in Textpad, create a new tool with these parameters:											   #
#																														   #
# 	  Command:    		YourPathToPerl\bin\perl.exe																		   #
#	  Parameters: 		perl.runsnippet.pl -source:"$File" -line:$Line -sel:"$Sel" -cb -eval $Clip $Prompt(Schalter:)	   #
#	  Initial Dir:		$FileDir																						   #
#	  Capture Output: 	check																							   #
#																														   #
#	Set $commandline as an appropriate little script, if you want to run something else than Perl-code.					   #
#	Let $browser point to your web browser if you want to use the switch -ashtml.										   #
#																														   #
############################################################################################################################

use strict;
use Win32::Clipboard;

# Diese wird via eval "" ausgefhrt:																						
my $commandline						= '%SEL%';				# hier kann man einen anderen Interpreter/Compiler eintragen,	
															# via Perls 'system()'. %SEL% wird durch den auszufhrenden		
															# Quelltext ersetzt.											
# Dieser wird via exec() aufgerufen, mit einem (hier erzeugten) $outputfile als Argument:									
my $browser							= 'C:/[Software]/Internet/Browser/Opera/opera.exe';															


#**************************************************************************************************************************#
my @argv;
while (my $arg = shift @ARGV) {
	last							  if $arg eq '--';
	push							  @argv, $arg;
}

my %akeys							= (qw(cb useclipboard f source l line p pos e eval lv listvars ls listsubs source source line line pos pos selection sel sel sel eval eval listvars listvars useclipboard useclipboard ashtm ashtm));
my %args							= map {my ($no, $key, $val)	= $_ =~ m/^-+(no)?(\w+)(?:[:=](.*))?$/;
											$no 					= $no ? 0 : 1;
											$key					= (defined ($key) && $akeys{$key}) || $_;
											($key, defined ($val) ? $val : $no)
										  } @argv;
$args{'cbsel'}						= Win32::Clipboard::GetText()							if $args{'useclipboard'};
#**************************************************************************************************************#
# usage...unless file...
my $msgs							= eval (join '', <DATA>);
(print								  msg('usage')), exit								unless @argv;
(print								  msg('500') . "\n" . msg('usage')),
 exit																					unless $args{'source'};

my $adjustlineno					= length $args{'sel'};
my $givenfile						= $args{'source'};
my $line							= $args{'line'};
my $pos								= $args{'pos'};
my $selection						= $args{'useclipboard'} ? $args{'cbsel'} : $args{'sel'};

chomp								  ($selection),
$selection							= join "\012", split /\015\012/, $selection				if $selection;
my $numlines						= $selection ? ($selection =~ tr/\012/\012/	+ 1) : 0;
my $firstline						= 0;
   $firstline						= ($args{'line'} - $numlines)							if $adjustlineno;

#**************************************************************************************************************#
sub msg	{
	my $s							= $msgs->{shift || ''} || '<invalid msgno>';
	$s								=~ s/(?<!\\)\%(\d+)/defined $_[$1] ? $_[$1] : ''/eg;
	$s;
}
my $outputfile						= $givenfile . '.tptool.htm';
## -ashtm: Wir mchten HTML-Ausgabe:																			
if ($args{'ashtm'}) {
	open							  (STDOUT, '>', $outputfile)							|| die "can't open outputfile '$outputfile': $!";
	open							  (STDERR, '>>', $outputfile)							|| die "can't open outputfile '$outputfile': $!";
	print							  "<html>\n\t<body>\n\t\t<pre>";
}

## -eval:  Wir mchten einen Schnipsel eval()uieren:															
(print								  msg (405)),
 $args{'eval'}						= 0														if $args{'eval'} && $givenfile eq $0;
if ($args{'eval'}) {
	
	print 							  msg ('110', $numlines);
	(print							  msg ('211')), exit								unless $selection;
	
	# Diese Zeile fhrt Quelltext als Perl-Skript aus. Ggf. einstellbar machen ($interpreter ?)					
	$commandline					=~ s/%SEL%/$selection/;
	my @result						= eval "$selection";
	if ($@) {
		chomp						  ($@);
		$@							=~ s/\(eval \d+\) line (\d+)/"$args{'source'} line " . ($firstline+$1) . '-1'/eg;
		$@							=~ s/, <DATA>[^.]*//g;
		$@							=~ s/\n/\012\011/g;
		print						  $msgs->{'212'}, "\n\t", $@;
	}
	print							  msg('111', $@ ? '...nix (Fehler).' : (join '', "\n", @result));	
}
## -listvars:  Wir mchten Variablen auflisten:																	
if ($args{'listvars'}) {
	my %vars;
	my @vars;
	my %pos;
	open (my $IN, '<', \$selection)															|| die $!;
	while (defined (my $line = <$IN>)) {
		while ($line =~ m/\b((my|our|local|state)\s*\(?\s*([&@%*\$]\w+(?:\s*,\s*[&@%*\$]\w+)*)\)?)/g) {
			my $varstr				= $1;
			my $prefix				= $2;
			my @names				= split /\s*,\s*/, $3;
			my $pos					= pos ($line) - length ($varstr) + 1;
			my $type;
			push					  @vars, @names;
			push					  @{$vars{$prefix}{$_}}, $firstline + $. . "-$pos"	   for @names;
			push					  @{$pos{$_}}, [$., $pos]							   for @names;
		}
	}
	close							  ($IN)													|| die $!;
	
	my @result;
	my $maxlen						= 0;
	length ($_) > $maxlen && ($maxlen = length ($_))					for @vars;
	my $indent						= ' ' x ($maxlen += 2);

	foreach my $prefix (qw(my state our local) ) {
		my $pv						= $vars{$prefix}					|| next;
		push						  @result, "\n$prefix-vars:";
		my @pv						= map		{my $s 				= $_.$indent; 
												 my $str			= "\n\t" . substr ($s, 0, $maxlen) .  (join "\n\t$indent", @{$pv->{$_}});
												 $str				=~ s!(\d+)-(\d+)!<a href="textpad://localhost/$givenfile?line=$1&pos=$2">$1-$2</a>!g	if $args{'ashtm'};
												 $str
												} 
										sort	{ lc ($a) cmp lc($b) }
										  keys %{$pv};
		push						  @result,  @pv;
	}
	   
	print							  @result ? (msg('120', $givenfile), @result) : msg('121', $givenfile);
}

if ($args{'ashtm'}) {
	print							  "\n\t\t</pre>\n\t</body>\n</html>";
#	close (STDIN);
#	close (STDERR);
	exec  ($browser, $outputfile);
}
#**************************************************************************************************************#

__DATA__
my $msgs							= { '101',		"fertig.",
										'110', 		"\n*** eval()uiere Codeschnipsel (%0 Zeilen)...",
										'111',		"\n*** eval() liefert:%0",
										'211',		"nix zum eval()uieren gegeben.",
										'212',		"*** Fehler gefunden:",
										
										'120',		"\n*** Vars found in \"%0\": ***",
										'121',		"\n*** No vars found in \"%0\". ***\n",
										
										'405',		"\n*** Won't eval() myself. ***",
										'500',		"\n*** Oops. No file given to 'perl.runsippet.pl'.  ***",
										'usage',	"\nperl.runsnippet.pl - run selection through perl, list vars or subs".
													"\nUsage:   perl perl.runsnippet.pl [args]".
													"\nThese [args] are recognized:\n".
													"\n    -source,       -s       the path/name of the file to be handled (mandatory)".
													"\n    -eval,         -e       run selected text through perl".
													"\n    -listvars,     -lv      create a list of variables from selected text".
													"\n    -listsubs,     -ls      dito for subroutines".
													"\n    -useclipboard, -cb      fetch text from clipboard".
													"\n    --                      args following this will be left in \@ARGV".
													"\n\n    Specifying -no[arg]     will switch off that feature.".
													"\n    If an argument takes a value, separate it from it's name with ':' or '='.".
													"\n",
									  };

__END__
